@rem = '--*-Perl-*--
@echo off
set FROMBAT=1
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S %0 %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!perl
#line 15

# $Id: listbps.bat,v 1.2 2008/03/24 13:01:11 maeda Exp $

# Copyright 2008 by Kaoru Maeda <kaoru.maeda@gmail.com>
#
# This program is free software; you may redistribute it and/or modify it
# under the same terms as Perl itself.

use strict;
use Encode;
use MP3::Info;

my @files = @ARGV;
@files or @files = ".";
if (-d $files[0]) {
    opendir (DIR, $files[0]);
    @files = map {"$files[0]/$_"} sort grep {/\.(flv|mp3)$/oi} readdir(DIR);
    closedir DIR;
}

for my $src_s (@files) {
    my $audiorate = $src_s =~ /\.flv$/ ?
	get_flv_audiodatarate($src_s) :
	    get_mp3_audiodatarate($src_s);
    my $src_u = slashize($src_s);
    $src_u =~ s[.*/][];
    printf("%8.2f  $src_u\n", $audiorate);
}

if ($ENV{FROMBAT}) {
    $|=1;
    print "^[L[ŕ܂: ";
    my $ans = <STDIN>;
}

sub get_flv_audiodatarate {
    my $file = shift;
    open IN, "<$file";
    binmode IN;
    my $data = '';
    sysread(IN, $data, 0x400);
    close IN;
    my $audiorate = 0;
    if ($data =~ /\x00\x0daudiodatarate\x00(........)/sm) {
        my $rate_le = reverse $1;
	$audiorate = unpack("d", $rate_le);
    }
    $audiorate;
}

sub get_mp3_audiodatarate {
    my $file = shift;
    my $info = get_mp3info($file);
    $info->{BITRATE};
}

sub slashize {
    pathdelim_convert($_[0], 'slash');
}

sub pathdelim_convert {
    my ($src, $dir) = @_;
    my $usrc = decode('sjis', $src);
    if ($dir eq 'back') {
	$usrc =~ s[/][\\]g;
    } elsif ($dir eq 'slash') {
	$usrc =~ s[\\][/]g;
    }
    encode('sjis', $usrc);
}

__END__
:endofperl
