# -*- perl -*-
# $Id: values.pl,v 1.7 2008/04/09 22:11:39 maeda Exp $

# Copyright 2008 by Kaoru Maeda <kaoru.maeda@gmail.com>
#
# This program is free software; you may redistribute it and/or modify it
# under the same terms as Perl itself.

# Encoding: ̃t@Cshiftjis

use strict;
use File::Spec;
our $C;
our %FFmpeg_tags;
our %GetWave;

# preference values that you can override in config.pl

## install-time parameters
$C->{UseSoundEngine} = 1;
$C->{SoundEngine}{ShowAutoMaxDialog} = 1;
$C->{SoundEngine}{AutoMaxLevel} = -12;
$C->{SoundEngine}{ConfigDir} = "$ENV{APPDATA}\\Cycle of 5th\\SoundEngine";
$C->{SoundEngine}{UsePsyencForMP3Decode} = 0;

$C->{UseWaveGain} = 0;
$C->{WaveGain}{Params} = '-y -n -g 9 ';

$C->{UseItunes} = 0;
$C->{iTunes}{UseNicoThumbNail} = 1;
$C->{iTunes}{SelectPlayList} = undef;
$C->{iTunes}{GetAttlibs} = undef;
$C->{iTunes}{AfterAdded} = undef;

$C->{AimedAudioBP}	= 128;
$C->{AimedVideoBP}      = 512;
$C->{AimedVideoWidth}   = 320;
$C->{ABPLadder}         = [192, 128, 96, 64, 32];
$C->{VBPLadder}         = [640, 512, 320, 300, 256, 192];
$C->{VWLadder}          = [640, 512, 320, 256, 176];
$C->{DefaultOutputFormat} = 'ipod';

## run-time parameters
$C->{TmpDir} = File::Spec->catfile($C->{Home}, "tmp");
$C->{LogFile}           = undef;
$C->{CommandLogFile}    = undef;
$C->{FileNameEncoding}  = 'cp932';

$C->{WaveGain}{Program}   = File::Spec->catfile($C->{Home}, "WaveGain.exe");
$C->{SwfExtract}{Program} = File::Spec->catfile($C->{Home}, "swfextract.exe");
$C->{FFMpeg}{Program}     = File::Spec->catfile($C->{Home}, "ffmpeg.exe");
$C->{Format}{"avi"}{Description} = "avi : Xvid/MP3 COWON D2";
$C->{Format}{"avi"}{FFMpeg} = "-vcodec libxvid -flags bitexact -acodec libmp3lame ";
$C->{Format}{"ipod"}{Ext} = 'mp4';
$C->{Format}{"ipod"}{FFMpeg} = "-f ipod ";
$C->{Format}{"ipod"}{Description} = "mp4 : H264/AAC iPod";
$C->{Format}{"mp4"}{FFMpeg} = "-f ipod ";
$C->{Format}{"mp4"}{Description} = "mp4 : ̂Ƃ ipod Ɠݒ";
$C->{Format}{"mp3"}{FFMpeg} = "-f mp3 ";
$C->{Format}{"mp3"}{NoVideo} = 1;
$C->{Format}{"mp3"}{Description} = "mp3 ";
$C->{Format}{"3gp"}{FFMpeg} = "-vcodec mpeg4 -acodec libfaac -flags bitexact ";
$C->{Format}{"3gp"}{Description} = "3gp : MPEG4/AAC";

$C->{InputType}         = qr/(?:flv|swf|mp4|mp3|m4a|3gp|3g2|mov|avi|wav|mpg|mpeg|wmv|wma|rm)/i;
$C->{VideoInputType}    = qr/(?:flv|swf|mp4|3gp|3g2|mov|avi|mpg|mpeg|wmv|rm)/i;
$C->{NicoPrefix}        = qr/(?:sm|nm|yt|fz|am|nl|ut|ca|ax|za|zb|zc|yo)/i;

# hooks that you can override in userdef.pl

## Character Encodings
#   choose_encoding($enc, $value, $key) -> encoding
$C->{ChooseTagEncoding}	= undef;

## Audio Encoding Parameters
#  audio_encparams($srcfile, $dstfile, $meta) -> string
$C->{GetAudioEncParams}         = undef;
$C->{GetAudioEncParamsForVideo} = undef;
## Video Encoding Parameters
#  video_encparams($srcfile, $dstfile, $meta, $videofile) -> string
$C->{GetVideoEncParams}         = undef;

1;
